#!/system/bin/sh
#
# Ultimatic Jar Patcher Tools RC7 created by -=zeppelinrox=-
#
# When using scripting tricks, ideas, or code snippets from here, please give proper credit.
# There are many things may look simple, but actually took a lot of time, trial, and error to get perfected.
#
# This script can be used freely and can even be modified for PERSONAL USE ONLY.
# It can be freely incorporated into ROMs - provided that proper credit is given WITH a link back to the XDA thread.
# If you want to share it or make a thread about it, just provide a link to the main thread.
#      - This ensures that users will always be getting the latest versions.
# Prohibited: Any modification (excluding personal use), repackaging, redistribution, or mirrors of my work are NOT PERMITTED.
# Thanks, zeppelinrox.
#
# This script automates the patching of services.jar for SuperCharging and Maximum MultiTasking!
#
# See http://goo.gl/IvGL1 - Ultimatic Jar Patcher Tools thread at XDA
# See http://goo.gl/qM6yR - SuperCharger thread at XDA
#
# Mod 1. "Jelly ISCream" for ICS, Jelly Bean and above. This will SuperCharge Your Home Launcher and ADJ/OOM Priorities!
#
# Mod 2. "Maximum MultiTasking Mods" for Froyo and above has a few parts.
#        a. "Maximum Overdrive" - This lets you run up to 70 hidden apps instead of the default 15 (RAM permitting) without breaking the lowmemorykiller!
#           (Huge thanks to Dorimanx from XDA Forums for ideas and the initial mod to bypass the lowmemorykiller for greater multitasking!)
#        b. "Minimum Hidden Protection" - This keeps 15 hidden apps (doing background tasks) in memory before empty apps (least important) can push any of them out. Default is only 2!
#        c. "Time Killer Killer" - This tries to bypass the 30 minute service inactivity limit by increasing it to 24 hours.
#        d. "Service Preserver" - (Post-ICS ROMS) This prevents service apps (ie. recently ran apps) from being becoming a "worstType" and therefore, less likely to be killed.
#        e. "ProActive Booster" - (Pre-ICS ROMS) This changes the processes limit from 2 to 50 and activities limit from 20 to 70.
#        f. "Total Recall" - This makes Android remember 50 recent tasks instead of the default 20. (Not yet working properly)
#
# Mod 3. "Non-Sense App Limit" for Sense 4 and above (Not needed for Sense 3.6 and below).
#        This eliminates additional restrictions introduced with Sense 4.
#        a. Visible tasks increased from 8 apps to 50 (RAM permitting)
#        b. Something called "HTC Recent App Fusion" is rendered a non-factor.
#
# Mods 2 and 3 (where applicable) let you use your RAM to its Fullest MultiTasking Potential!
#
# Usage Notes:
# 1. Mods 1 and 2 will edit ActivityManagerService.smali (Froyo and up) and ProcessList.smali (I SCream Sandwich [sic] and Jelly Bean)
#    Mod 3, for Sense 4 and above, only needs to patch ActivityManagerService.smali
# 2. The smali file(s) need be in the same location as this script.
# 3. Put the files on the sd card and run this script on the Android device itself using Script Manager or Terminal Emulator.
#    Alternatively, you can run it on a PC, whether it be Linux or Mac OSX or Windows (using Cygwin - which is free and easy to set up).
#
  #####################
 #  IMPORTANT NOTES  #
#####################
# In case of lag, due to too many apps running, RAISE the minfree levels.
# For bettter MultiTasking, LOWER minfree levels.
#
# It's HIGHLY recommended to use my V6 SuperCharger script to apply these minfree settings and PROPERLY take advantage of the new priorities!
#
# For debugging, delete the # at the beginning of the next line to see what may have fubarred.
# set -x
#
line===========================================================
cd "${0%/*}" 2>/dev/null
smalifolder="smali_files/com/android/server/am"
livemode=yes
servicesfile=services.jar
javatesturl="http://www.java.com/en/download/installed.jsp"
LOG_FILE=ultimatic_log.txt
LOG_IT="tee -a $LOG_FILE"
if [ "`ps | grep launchd`" ] || [ "`ps | grep mach_init`" ]; then OSX=yes; adb="./adb-mac"
elif [ "`env | grep windows`" ]; then adb="adb"
else adb="./adb"
fi
chmod a+x adb* | $LOG_IT
mkdir -p backup
mkdir -p supercharged
mkdir -p patch_this
clear
printf "\e[3;400;0;t"
printf "\e[8;10;14;t"
echo "     HEY!"
sleep 1
clear
printf "\e[8;20;30;t"
echo "          What's Up?"
sleep 1
clear
printf "\e[8;32;40;t"
echo "         I may need more ROOM!"
sleep 1
clear
printf "\e[8;42;50;t"
echo "         Just a sec... I think I got it..."
sleep 1
clear
printf "\e[8;54;58;t"
echo "         YEP! This feels pretty good now... LOL!!"
sleep 2
clear
echo " Running $0" > $LOG_FILE
echo "" | $LOG_IT
if [ "$LOG_FILE" ];then
	echo " Start Time: `date`"
	echo ""
	echo "     ==============================================="
	echo "      \\\\\\\\\\  -=ULTIMATIC JAR PATCHER TOOLS=-  /////"
	echo "       ==========================================="
	echo ""
	echo " This tool will AutoMagically patch services.jar like so:"
	echo ""
	echo " It pulls files from your device, patches and installs!"
	echo ""
	echo " Mod 1. \"Jelly ISCream\" to SuperCharge launchers..."
	echo ""
	echo " Mod 2. \"Maximum MultiTasking Mods\" for Froyo and up..."
	echo ""
	echo " Mod 3. \"Non-Sense App Limit\" for Sense 4 and up..."
	echo ""
	echo $line
	echo " Cool Trick for Deodexed ROMS!"
	echo $line
	echo ""
	echo " If you DON'T have a services.odex..."
	echo ""
	echo " You can put services.jar in the \"patch_this\" folder!"
	echo ""
	echo " You will then have an option to \"patch this\" instead!"
	echo ""
	echo " Otherwise, files will just be pulled from the phone ;^]"
	echo ""
	echo $line
	if [ ! -f "patch_this/services.jar" ];then
		echo " If you want, copy services.jar to \"patch_this\" now!"
		echo $line
		echo ""
		echo -n " Press the enter key when ready... "
		read enter
		echo "" | $LOG_IT
		echo $line
	fi
fi | $LOG_IT
if [ ! "`which java`" ]; then
	if [ "$LOG_FILE" ];then
		echo " Java is NOT Installed... Abort! Abort!"
		echo $line
		echo ""
		echo -n " Time to get some Java... Press the enter key! "
		read enter
		echo "" | $LOG_IT
		if [ "$OSX" ]; then open "$javatesturl"
		elif [ "$BROWSER" ]; then $BROWSER "$javatesturl"
		elif [ "`which xdg-open`" ]; then xdg-open "$javatesturl"
		elif [ "`which gnome-open`" ]; then gnome-open "$javatesturl"
		fi 2>/dev/null
		echo " Try again after Java installation is complete!"
		echo ""
		echo " But if it is installed, you need to add it..."
		echo ""
		echo "               ...to the PATH statement... Google it! ;^]"
		echo ""
		echo -n " So come back when you got your Java together! "
		read enter
		echo "" | $LOG_IT
		echo $line
		echo ""
	fi | $LOG_IT
	exit 69
else echo " Java is installed... nice!" | $LOG_IT
fi 2>/dev/null
if [ -f "patch_this/services.jar" ];then
	echo $line | $LOG_IT
	echo "" | $LOG_IT
	if [ ! -f "patch_this/services.odex" ]; then
		if [ "$LOG_FILE" ];then
			echo " YES! Found patch_this/services.jar!"
			echo ""
			echo " You want to \"patch this\" services.jar or do \"Live\" mode?"
			echo ""
			echo -n " Enter P to \"patch this\", any key for \"Live\" mode: "
		fi | $LOG_IT
		read patchthis
		echo $patchthis >> $LOG_FILE
		echo "" | $LOG_IT
		if [ "$patchthis" = "P" ] || [ "$patchthis" = "p" ]; then livemode=
			if [ "$LOG_FILE" ];then
				cp -f patch_this/services.jar .
				echo " COOL! Do you want to install it right after?"
				echo ""
				echo " BIG NOTE! If install fails due to ADB failure..."
				echo ""
				echo "   ...just patch it offline (say \"No\" next) and..."
				echo ""
				echo "          ...copy the patched services.jar to the sdcard."
				echo ""
				echo " Then install it manually or use..."
				echo ""
				echo "             ...V6 SuperCharger's \"Jelly ISCream Parlor\"!"
				echo ""
				echo -n " Enter I to install it, any key for No: "
			fi | $LOG_IT
			read installit
			echo $installit >> $LOG_FILE
			echo "" | $LOG_IT
			if [ "$installit" = "I" ] || [ "$installit" = "i" ]; then installthis=yes; fi
			if [ "$LOG_FILE" ];then
				echo $line
				if [ "$installthis" ];then echo " OK! Gonna \"patch this\" services.jar and install it too!"
				else echo " OK! Gonna \"patch this\" services.jar and just stop lol :p"
				fi
			fi | $LOG_IT
		fi
	else
		if [ -f "patch_this/services.odex" ];then
			echo " Found services.odex in the \"patch_this\" folder..."
			echo ""
			echo "                                  ...that WON'T work..."
			echo ""
			echo "    ...services.odex can only be patched while connected!"
			echo ""
		fi | $LOG_IT
	fi
fi
echo $line | $LOG_IT
if [ "$livemode" ] || [ "$installthis" ];then liveinstall=yes
	if [ "$LOG_FILE" ];then
		echo ""
		echo " Connect your device via USB or WiFi (ie. Wireless ADB!)"
		echo ""
		echo " To use ADB Wirelessly, enter your internal IP and port #"
		echo ""
		echo " Example: 192.168.0.69:1234"
		echo ""
		echo " But, if your port is 5555, just the IP alone is fine."
		echo ""
		echo " To connect your device via USB..."
		echo ""
		echo "             ...DISABLE Memory Card Access! (Charge Only)"
		echo ""
		echo "       ...ENABLE Android Debugging (Settings>Dev Options)"
		echo ""
		echo "                            ...and DISABLE Wireless ADB!!"
		echo ""
		echo " If both methods fail..."
		echo ""
		echo "        ...be sure drivers for your device are installed!"
		echo ""
		echo " Enter an IP for Wireless ADB or..."
		echo ""
		echo -n " Just press the enter key for USB: "
	fi | $LOG_IT
	read method
	echo $method >> $LOG_FILE
	echo "" | $LOG_IT
	$adb kill-server
	echo $line | $LOG_IT
	if [ "`echo $method | grep "[0-9]" | grep "\." | grep -v "[a-zA-Z]"`" ];then
		echo "                     Wireless ADBaby!" | $LOG_IT
		echo $line | $LOG_IT
		$adb connect $method
	else
		echo "              You're All Wired Up... I Hope!" | $LOG_IT
		echo $line | $LOG_IT
		$adb wait-for-device
	fi
	echo $line
	if [ "$LOG_FILE" ];then
		echo ""
		echo " It's better to run adb as Root if you can!"
		echo ""
		echo " If it don't work, just try again and say no next time..."
		echo ""
		echo "                         ...since it should still work :P"
		echo ""
		echo -n " Restart adb as root? Enter Y for Yes, any key for No: "
		read adbroot
		echo $adbroot >> $LOG_FILE
		echo ""
		if [ "$adbroot" = "Y" ] || [ "$adbroot" = "y" ]; then echo -n " "; $adb root; echo ""; fi
		echo $line
	fi | $LOG_IT
	storage=$($adb shell echo \${EXTERNAL_STORAGE#*mnt} | tr -d '\r')
	busybox=$($adb shell which busybox)
	busyboxver="$($adb shell busybox | awk 'NR==1{print $1,$2}')"
	syspart="$($adb shell busybox mount | awk '$3=="/system"{print $1,$3}')"
	newer=$($adb shell "for newer in \`busybox ls -lc $storage/V6_SuperCharger/services.jar.unsuper /system/bin/adb | awk '{print \$9}'\`; do break; done 2>/dev/null")
	if [ "$busybox" ]; then
		if [ "$LOG_FILE" ];then
			echo " Found $busyboxver!"
			echo $line
			echo ""
			echo " But if you see any \"applet\" not found errors..."
			echo ""
			echo "                      ...you need a better busybox build!"
			echo ""
			echo $line
		fi | $LOG_IT
	else
		if [ "$LOG_FILE" ];then
			echo " BusyBox was NOT found... Abort! Abort!"
			echo $line
			echo ""
			echo -n " Try again after BusyBox is installed! "
			read enter
			echo "" | $LOG_IT
			echo $line
			echo ""
		fi | $LOG_IT
		exit 69
	fi
	if [ "$LOG_FILE" ];then
		echo " Storage partition is $storage"
		echo $line
		$adb shell su -c "echo ultimatic has access > $storage/ultimatic.tmp 2>/dev/null"
		$adb pull $storage/ultimatic.tmp . 2>/dev/null
	fi | $LOG_IT
	if [ "`cat ultimatic.tmp`" ]; then
		if [ "$LOG_FILE" ];then
			echo " $storage is accessible... So far so good!"
			echo $line
			echo ""
			rm *.tmp 2>/dev/null
		fi | $LOG_IT
	else
		if [ "$LOG_FILE" ];then
			echo $line
			echo " $storage is NOT accessible... Abort! Abort!"
			echo $line
			echo ""
			echo -n " Press the enter key and try again later! "
			read enter
			echo "" | $LOG_IT
			echo $line
			echo ""
		fi | $LOG_IT
		exit 69
	fi 2>/dev/null
	if [ "$livemode" ];then
		rm services.* 2>/dev/null
		echo " Pulling services.* from your Android thingie!"
		echo ""; echo -n " "
		$adb shell su -c "rm $storage/ALL_ROMS_Ultimate_Jar_Power_Tools* 2>/dev/null"
		$adb pull /system/framework/services.jar .
		$adb pull /system/framework/services.odex . 2>/dev/null
		echo ""
		echo $line
	fi | $LOG_IT
	if [ "$livemode" ] && [ -f "services.odex" ]; then
		servicesfile=services.odex
		odexed=yes
		api=$($adb shell grep ro.build.version.sdk /system/build.prop | sed 's/.*=//' | tr -d '\r')
		BCP=$($adb shell echo \$BOOTCLASSPATH | sed 's@:/system/framework/services.jar@@' | tr -d '\r')
	fi
	if [ "$LOG_FILE" ];then
		if [ "$odexed" ]; then
			echo " api level is $api (used for baksmali)"
			echo $line
		fi
		echo ""
		echo " Some info about your current $servicesfile..."
		echo ""
		echo $line
		echo -n " "
		$adb shell busybox ls -l /system/framework/$servicesfile | tr -d '\r'
		echo $line
		echo ""
		echo " It's size and timestamp should change later!"
		echo ""
		echo -n " Press the enter key when ready... "
		read enter
		echo "" | $LOG_IT
		echo $line
		if [ "$odexed" ]; then
			echo " This ROM is ODEXED... cross your fingers..."
			echo $line
			echo ""
			echo "                ...because I have extra work to do... lol"
			echo ""
			echo " Now pulling the entire system/framework folder!"
			echo ""
			$adb pull /system/framework framework
			echo ""
			echo " Installing dexopt-wrapper to /data..."
			echo ""; echo -n " "
			$adb shell su -c "mount -o remount,rw /data 2>/dev/null"
			$adb shell su -c "busybox mount -o remount,rw /data 2>/dev/null"
			$adb push dexopt-wrapper $storage/
			$adb shell su -c "cp -f $storage/dexopt-wrapper /data/"
			$adb shell su -c "chown 0.0 /data/dexopt-wrapper"
			$adb shell su -c "chmod 777 /data/dexopt-wrapper"
			$adb shell su -c "rm $storage/dexopt-wrapper"
			echo ""
			echo $line
		fi
	fi | $LOG_IT
fi
if [ "$LOG_FILE" ];then
	rm -r smali_files 2>/dev/null
	echo ""
	echo " Running baksmali to decompile and get smalis..."
	echo ""
	if [ "$odexed" ]; then java -jar baksmali.jar -x -a $api -d framework $servicesfile -o smali_files
	else java -jar baksmali.jar -x $servicesfile -o smali_files
	fi
	echo " Backing up files to /backup folder..."
	echo ""
	cp -f $smalifolder/ActivityManagerService.smali backup/
	cp -f $smalifolder/ProcessList.smali backup/ 2>/dev/null
	cp -f services.jar backup/
	if [ "$odexed" ]; then
		cp -f services.jar supercharged/
		cp -f $servicesfile backup/
	else unzip -oq $servicesfile classes.dex -d backup
	fi
	echo " Copying smali files needed for patching..."
	echo ""
	cp -f $smalifolder/ActivityManagerService.smali .
	cp -f $smalifolder/ProcessList.smali . 2>/dev/null
	echo $line
	echo " About to run Ultimate Jar Power Tools..."
	echo $line
	echo ""
	echo -n " Press the enter key when ready... "
	read enter
	echo "" | $LOG_IT
	echo $line
	echo "" >> $LOG_FILE
	sh ALL*
	cp -f ActivityManagerService.smali $smalifolder/ActivityManagerService.smali
	cp -f ProcessList.smali $smalifolder/ProcessList.smali 2>/dev/null
	echo " Creating new classes.dex file..."
	echo ""
	java -jar smali.jar smali_files -o classes.dex
	if [ ! "`which zip`" ]; then
		echo $line
		echo " Ugh... zip isn't installed..."
		echo $line
		echo ""
		if [ ! "$OSX" ]; then
			echo " I'll try and do it for you tho... heh."
			echo ""
			sudo apt-get install zip 2>/dev/null
			sudo yum install zip 2>/dev/null
			echo ""
		fi
	fi
	if [ ! "`which zip`" ]; then
		if [ ! "$OSX" ]; then
			echo " Damn... looks like it didn't work :P"
			echo ""
			echo -n " You install Linux's"
		else echo -n " You install OSX's"
		fi
		echo " zip command for next time!"
		echo ""
		echo " It's probably Zip v3.0 and made by \"Info-ZIP\""
		echo ""
		echo " Open up services.jar with a zip utility..."
		echo ""
		echo "                    ...and add the new classes.dex to it!"
		echo ""
		echo $line
		echo ""
		echo -n " Press the enter key when ready... "
		read enter
		echo "" | $LOG_IT
	else echo " Updating services.jar with Info-ZIP!"
		echo ""; echo -n " "
		zip -r services.jar classes.dex 2>/dev/null
		echo ""
	fi
fi | $LOG_IT
if [ "$liveinstall" ];then
	if [ "$newer" = "/system/bin/adb" ]; then
		echo " Backing up files to $storage/V6_SuperCharger..."
		echo ""
		echo $line
		echo " This allows you to restore original services.* files..."
		echo $line
		echo ""
		echo "     ...with the Jelly ISCream Parlor in V6 SuperCharger!"
		echo ""
		echo $line
		echo ""
		$adb shell su -c "cp -fr /system/framework/services.jar $storage/V6_SuperCharger/services.jar.unsuper"
		$adb shell su -c "cp -fr /system/framework/services.odex $storage/V6_SuperCharger/services.odex.unsuper 2>/dev/null"
	fi
	$adb shell su -c "mount -o remount,rw /system 2>/dev/null"
	$adb shell su -c "busybox mount -o remount,rw /system 2>/dev/null"
	$adb shell su -c "busybox mount -o remount,rw $syspart 2>/dev/null"
	$adb shell su -c "busybox mkdir -p $storage/V6_SuperCharger"
	$adb push services.jar $storage/
	if [ "$odexed" ]; then
		echo " Pushing new services.jar to /system/framework..."
		echo ""; echo -n " "
		$adb shell su -c "rm /system/framework/services_new.odex 2>/dev/null"
		$adb shell su -c "cp -f $storage/services.jar /system/framework/services_new.jar"
		echo ""
		echo " Creating new $servicesfile..."
		echo ""
#		$adb shell su -c "/data/dexopt-wrapper /system/framework/services_new.jar /system/framework/services_new.odex \$BOOTCLASSPATH"
		$adb shell su -c "/data/dexopt-wrapper /system/framework/services_new.jar /system/framework/services_new.odex $BCP"
		echo ""
		newodexexist=$($adb shell "ls /system/framework/services_new.odex 2>/dev/null")
		if [ ! "$newodexexist" ]; then
			echo " Doh... I don't think it worked..."
			echo ""
			echo "                                     ...gonna try Plan B!"
			echo ""
			echo " Pushing new services.jar to $storage"
			echo ""; echo -n " "
			$adb shell su -c "rm $storage/$servicesfile 2>/dev/null"
			echo ""
			echo " Creating new $servicesfile on $storage..."
			echo ""
#			$adb shell su -c "/data/dexopt-wrapper $storage/services.jar $storage/$servicesfile \$BOOTCLASSPATH"
			$adb shell su -c "/data/dexopt-wrapper $storage/services.jar $storage/$servicesfile $BCP"
			echo ""
			echo " Applying \"special sauce\" to $servicesfile..."
			echo ""; echo -n " "
			$adb shell su -c "busybox dd if=/system/framework/$servicesfile of=$storage/$servicesfile bs=1 count=20 skip=52 seek=52 conv=notrunc | tr -d '\r'"
			$adb pull $storage/$servicesfile .
			echo ""
			echo $line
			echo " Installing patched $servicesfile!"
			echo $line
			$adb shell su -c "cp -f $storage/$servicesfile /system/framework/"
		else
			echo " Applying \"special sauce\" to $servicesfile..."
			echo ""; echo -n " "
			$adb shell su -c "busybox dd if=/system/framework/$servicesfile of=/system/framework/services_new.odex bs=1 count=20 skip=52 seek=52 conv=notrunc | tr -d '\r'"
			$adb pull /system/framework/services_new.odex $servicesfile
			echo ""
			echo $line
			echo " Installing patched $servicesfile!"
			echo $line
			$adb shell su -c "cp -fr /system/framework/services_new.odex $storage/$servicesfile"
			$adb shell su -c "mv /system/framework/services_new.odex /system/framework/$servicesfile"
			$adb shell su -c "rm /system/framework/services_new.jar 2>/dev/null"
		fi
		$adb shell su -c "rm /data/dexopt-wrapper"
		$adb shell su -c "rm $storage/services.jar"
	else
		echo $line
		echo " Installing patched $servicesfile!"
		echo $line
		echo ""; echo -n " "
		$adb shell "rm $storage/V6_SuperCharger/services.odex.unsuper 2>/dev/null"
		$adb shell su -c "cp -f $storage/$servicesfile /system/framework/"
	fi
	$adb shell su -c "chown 0.0 /system/framework/$servicesfile"
	$adb shell su -c "chmod 644 /system/framework/$servicesfile"
	echo ""
	$adb push V6*.sh $storage/
	$adb shell su -c "for V6 in \`busybox ls -t $storage/V6*.sh\`; do if [ ! "\$newest" ]; then newest=found; else rm \$V6 2>/dev/null; fi; done"
	$adb shell su -c "mount -o remount,ro /system 2>/dev/null"
	$adb shell su -c "busybox mount -o remount,ro /system 2>/dev/null"
	$adb shell su -c "busybox mount -o remount,ro $syspart 2>/dev/null"
fi | $LOG_IT
if [ "$LOG_FILE" ];then
	mv *.smali supercharged/ 2>/dev/null
	mv classes.dex supercharged/ 2>/dev/null
	if [ "$odexed" ]; then
		mv $servicesfile supercharged/ 2>/dev/null
		mv services.jar supercharged/services_deodexed.jar
	else
		mv $servicesfile supercharged/ 2>/dev/null
		rm supercharged/services.odex 2>/dev/null
		rm supercharged/services_deodexed.jar 2>/dev/null
		if [ ! "$livemode" ]; then mv patch_this/$servicesfile backup/ 2>/dev/null; fi
	fi
	if [ "$liveinstall" ];then
		echo ""
		echo " NEW info about your current $servicesfile..."
		echo ""
		echo $line
		echo -n " "
		$adb shell busybox ls -l /system/framework/$servicesfile | tr -d '\r'
		echo $line
		echo ""
		echo " $servicesfile MUST have a brand new timestamp!"
		echo ""
		echo $line
		echo "            If it does not, it didn't work!!"
		echo $line
		echo ""
		echo " Now comparing to the new one I made on $storage..."
		echo ""
		echo $line
		$adb shell su -c "if [ \"\`diff /system/framework/$servicesfile $storage/$servicesfile\`\" ]; then echo \"   Crap"'!'" /framework/$servicesfile is NOT how I made it"'!'"\"; else echo \"    w00t"'!'" /framework/$servicesfile is PERFECTLY FINE"'!'"\"; fi"
		echo $line
		echo ""
		echo " If it didn't work..."
		echo ""
		echo "       ...post ultimatic_log.txt in the Ultimatic Thread!"
		echo ""
		echo " Also try to install it manually from $storage or use..."
		echo ""
		echo "             ...V6 SuperCharger's \"Jelly ISCream Parlor\"!"
		echo ""
		echo $line
		echo ""
		echo " And Hey! You can run the V6 SuperCharger script..."
		echo ""
		echo "                         ...RIGHT NOW from your computer!"
		echo ""
		echo $line
		echo " Type \"su\" and enter, \"sh $storage/V6*.sh\" and enter!"
		echo $line
		echo ""
		echo " Type \"reboot\" to reboot your device now!"
		echo ""
		echo " Type \"exit\" to uhhh... exit :D"
	else
		echo $line
		echo ""
		echo " OK! Find all the Super Stuff in the supercharged folder!"
		echo ""
		echo " I hope you know how to install $servicesfile manually lol"
	fi
	echo ""
	echo $line
	echo "   You NEED to reboot... Aaaaaand... That's All Folks!"
	echo $line
	echo ""
	echo " End Time: `date`"
	echo ""
	if [ "$liveinstall" ];then
		$adb shell
		$adb shell su -c "rm $storage/ultimatic.tmp 2>/dev/null"
		$adb kill-server
	fi
fi | $LOG_IT
sleep 1
